/**
 * Copyrightc2012 NTT DATA CORPORATION
 */

package com.sample;

import java.io.*;
import java.util.*;

public class HulftFileTransferJob {
	/**
	 * WMǗ̓o^At@C]̎s
	 */
	public static final String[] pre_env = { "HULEXEP=/usr/local/HULFT/bin","PATH=/usr/local/HULFT/bin:$PATH",
												"HULPATH=/usr/local/HULFT/etc" };//HULFT̊ϐ
	public static final String pre_win_huloplcmd_path = "C:\\HULFT Family\\hulft7\\etc\\opl\\huloplcmd.csv";//Windows̃R}hsÕpX
	public static final String pre_win_hulrcvlog_path = "C:\\HULFT Family\\hulft7\\etc\\hulrcvlg.dat";//Windows̏WMt@C̃pX
	public static final String pre_linux_huloplcmd_path = "/usr/local/HULFT/etc/opl/huloplcmd.csv";//Linux̃R}hsÕpX
	public static final String pre_linux_hulrcvlog_path = "/usr/local/HULFT/etc/hulrcvlog.dat";//Linux̏WMt@C̃pX
	public static final String pre_win_NT ="C:\\HULFT Family\\hulft7\\etc\\errfile\\NT.dat";//WindowsNT.dat̃pX
	public static final String pre_win_UX ="C:\\HULFT Family\\hulft7\\etc\\errfile\\UX.dat";//WindowsUX.dat̃pX
	public static final String pre_linux_NT ="/root/hulft_test/jobs/NT.dat";//LinuxNT.dat̃pX
	public static final String pre_linux_UX ="/root/hulft_test/jobs/UX.dat";//LinuxUX.dat̃pX

	public static void main(String[] args) {
		String os = osCheck();// sOS`FbN
		makeFile(os, args[0], args[1]);// WMǗ̃p[^t@C쐬
		addReceiveInfo(os);// WMǗ̓o^
		fileTransferJob(os, args[0], args[2]);// MvR}h̎s
		String error = getErrorCode(os);// G[R[h擾
		getMessage(os, error);//ڍ׃bZ[W\
	}

	//sOS`FbN
	public static String osCheck() {
		String osname = System.getProperty("os.name");
		return osname;
	}

	//WMǗ̃p[^t@C쐬
	public static void makeFile(String os, String fileid, String filename) {
		FileWriter fw = null;
		try {
			String newline = "";//s
			if (os.indexOf("Windows") != -1) {//Windows̏ꍇ
				newline = "\r\n";
			} else {//Linux̏ꍇ
				newline = "\n";
			}
			String[] rcv = { "RCVFILE=" + fileid, "FILENAME=" + filename,
					"OWNER=root", "GROUP=root", "PERM=777", "CODESET=A",
					"TRANSMODE=REP", "ABNORMAL=KEEP", "RCVTYPE=S", "GENCTL=NO",
					"JOBWAIT=T", "DATAVERIFY=0", "END" };//WMǗ̃p[^
			File fl = new File("./hulftrcv.txt");//p[^t@C
			fl.createNewFile();//t@C݂ȂꍇAt@C𐶐
			fw = new FileWriter(fl);
			for (int i = 0; i < rcv.length; i++) {//t@CɃp[^
				fw.write(rcv[i] + newline);//eڂ̃p[^{s
			}
		} catch (IOException e) {
			System.out.println(e.getMessage());
			e.printStackTrace();
		} finally {
			try{
				fw.close();
			} catch (IOException e) {
				System.out.println(e.getMessage());
				e.printStackTrace();
			}
		}
	}

	//WMǗ̓o^
	public static void addReceiveInfo(String os) {
		try {
			String command = "";//sR}h
			int ret = 0;//R}h̖߂l
			if (os.indexOf("Windows") != -1) {
				command = "\"C:\\HULFT Family\\hulft7\\binnt\\utliupdt.exe\" -f ./hulftrcv.txt -r";//WMǗo^R}h
				Runtime rt = Runtime.getRuntime();
				Process process = rt.exec(command);//R}h̎s
				ret = checkError(process);//R}h̎sʂ`FbN
			} else {
				String[] env = pre_env;//HULFT̊ϐ
				command = "/usr/local/HULFT/bin/utliupdt -f ./hulftrcv.txt -r";//WMǗo^R}h
				Runtime rt = Runtime.getRuntime();
				Process process = rt.exec(command, env);//R}h̎s
				ret = checkError(process);//R}h̎sʂ`FbN
			}
			if (ret != 0) {
				System.out.println("WMǗ̓o^Ɏs܂B");
				System.exit(2);//^[R[hu2vŏI
			} else {
				System.out.println("WMǗ̓o^܂B");
			}
		} catch (IOException e) {
			System.out.println(e.getMessage());
			e.printStackTrace();
		} 
	}

	//MvR}h̎s
	public static void fileTransferJob(String os, String fileid, String hostname) {
		try {
			String command = "";//sR}h
			int ret = 0;//R}h̖߂l
			if (os.indexOf("Windows") != -1) {//M悪Windows̏ꍇ
				command = "\"C:\\HULFT Family\\hulft7\\binnt\\utlrecv.exe\" -f "
						+ fileid + " -h " + hostname + " -sync";//MvR}h
				Runtime rt = Runtime.getRuntime();
				Process process = rt.exec(command);//R}h̎s
				ret = checkError(process);//R}h̎sʂ`FbN
			} else {//M悪Linux̏ꍇ
				String[] env = pre_env;//HULFT̊ϐ
				command = "/usr/local/HULFT/bin/utlrecv -f " + fileid + " -h "
						+ hostname + " -sync";//MvR}h
				Runtime rt = Runtime.getRuntime();
				Process process = rt.exec(command, env);//R}h̎s
				ret = checkError(process);//R}h̎sʂ`FbN
			}
			if (ret != 0) {
				System.out.println("t@C̓]Ɏs܂B");
			}else{
				System.out.println("t@C̓]܂B");
				System.exit(0);//^[R[hu0vŏI
			}
		} catch (IOException e) {
			System.out.println(e.getMessage());
			e.printStackTrace();
		} 
	}

	//G[R[h擾
	public static String getErrorCode(String os) {
		String error= "";//G[R[h
		BufferedReader br = null;
		FileInputStream fis = null;
		BufferedInputStream bis = null;
		try {
			String huloplcmd_path = "";//R}hsÕpX
			String hulrcvlog_path = "";//WMt@C̃pX
			String line = "";//Yt@C1s
			String lastline = "";//Ys
			String id = "";//ʎq
			byte[] buf;//1s1oCgi[
			
			if (os.indexOf("Windows") != -1) {
				huloplcmd_path = pre_win_huloplcmd_path;
				hulrcvlog_path = pre_win_hulrcvlog_path;
				buf = new byte[1280];//WMt@ĈPs̃oCg
			} else {
				huloplcmd_path = pre_linux_huloplcmd_path;
				hulrcvlog_path = pre_linux_hulrcvlog_path;
				buf = new byte[1088];//WMt@ĈPs̃oCg
			}
			File csv = new File(huloplcmd_path);
			br = new BufferedReader(new FileReader(csv));//R}hsOǂݍ
			while ((line = br.readLine()) != null) {//1sŏIs܂œǂݍ
				lastline = line;
			}
			StringTokenizer st = new StringTokenizer(lastline, "\",\"");//ŏIsu","vŋ؂
			int i = 0;
			while (st.hasMoreTokens()) {
				id = st.nextToken();
				if (i == 7) {//8Ԗڂ̃g[Nł鏈ʎq擾
					break;
				}
				i++;
			}
			fis = new FileInputStream(hulrcvlog_path);
			bis = new BufferedInputStream(fis);//WMt@Cǂݍ
			int len = bis.read(buf);
			String matchline;
			String [] errorcode = new String [8];
			while ( ( len = bis.read(buf) ) != -1 ) {//Psǂݍ݁Aʎqƈv邩mF
				matchline = new String(buf, 0, len);//ǂݍ񂾍s𕶎ɕϊ
				if(matchline.indexOf(id) != -1){//ʎqƈvI
					break;
				}
			}
			if (os.indexOf("Windows") != -1) {//Windows̏ꍇ
				for (i = 161; i <= 166; i++) {//16i161`164oCgڂ擾
					errorcode[i-161] = String.format("%1$x ", buf[i-1]);
					errorcode[i-161] = errorcode[i-161].length() == 2 ? "0" + errorcode[i-161] : errorcode[i-161];
				}
				errorcode[6] = errorcode[3].trim() + errorcode[2].trim() + errorcode[1].trim() + errorcode[0].trim();
				errorcode[7] = errorcode[5].trim() + errorcode[4].trim();//ڍ׃R[h
				int errorcode1 = Integer.parseInt(errorcode[6], 16);//10iɕϊ
				int errorcode2 = Integer.parseInt(errorcode[7], 16);//10iɕϊ
				errorcode1 = errorcode1%1000;//R[h
				errorcode[6] = String.format("%03d", errorcode1);//3ɐ`
				errorcode[7] = String.format("%05d", errorcode2);//5ɐ`
				error = errorcode[6] + errorcode[7];//R[h{ڍ׃R[h
			}else {
				for (i = 161; i <= 164; i++) {//16i161`164oCgڂ擾
					errorcode[i-161] = String.format("%1$x ", buf[i-1]);
					errorcode[i-161] = errorcode[i-161].length() == 2 ? "0" + errorcode[i-161] : errorcode[i-161];
				}
				errorcode[4] = errorcode[1].trim() + errorcode[0].trim();//R[h
				errorcode[5] = errorcode[3].trim() + errorcode[2].trim();//ڍ׃R[h
				int errorcode1 = Integer.parseInt(errorcode[4], 16);//10iɕϊ
				int errorcode2 = Integer.parseInt(errorcode[5], 16);//10iɕϊ
				errorcode[4] = String.format("%04d", errorcode1);//4ɐ`
				errorcode[5] = String.format("%04d", errorcode2);//4ɐ`
				error = errorcode[4] + errorcode[5];//R[h{ڍ׃R[h
			}
		} catch (FileNotFoundException e) {
			System.out.println(e.getMessage());
			e.printStackTrace();
		} catch (IOException e) {
			System.out.println(e.getMessage());
			e.printStackTrace();
		} finally {
			try{
				br.close();
				fis.close();
				bis.close();
			} catch (IOException e) {
				System.out.println(e.getMessage());
				e.printStackTrace();
			}
		}
		return error;
	}

	//WG[o͂Ɩ߂l\
	public static int checkError(Process process) {
		int ret = 0;//R}h̖߂l
		InputStream stream = null;
		BufferedReader br = null;
		try {
			ret = process.waitFor();
			stream = process.getInputStream();
			br = new BufferedReader(new InputStreamReader(stream));
			if (ret != 0) {//R}h̖߂l0łȂꍇ
				String line;
				while ((line = br.readLine()) != null) {//WG[ǂݍ
					System.out.println(line);//WG[̏o
				}
				System.out.println("߂lF" + ret);//߂l̏o
			}
		} catch (IOException e) {
			System.out.println(e.getMessage());
			e.printStackTrace();
		} catch (InterruptedException e) {
			System.out.println(e.getMessage());
			e.printStackTrace();
		} finally {
			try{
				stream.close();
				br.close();
			} catch (IOException e) {
				System.out.println(e.getMessage());
				e.printStackTrace();
			}
		}
		return ret;
	}

	//ڍ׃bZ[W\
	public static void getMessage(String os, String errorcode){
		String [] filepath = new String[2];//G[t@C̃pX
		String fileerrorcode = "";//G[t@CƈvG[R[h
		if(os.indexOf("Windows")!=-1){//M悪Windows̏ꍇ
			filepath[0] =pre_win_NT;//NT.dat̃pX
			filepath[1] =pre_win_UX;//UX.dat̃pX
			int winerrorcode = Integer.parseInt(errorcode);
			if((winerrorcode/100000)==406){//R[huxxx406(00xxx)v̏ꍇ
				fileerrorcode = Integer.toString(winerrorcode%1000);
				searchErrorcode(filepath[0], fileerrorcode);//MWIndows̏ꍇbZ[Wo
				fileerrorcode = "0" + Integer.toString(winerrorcode%1000);
				searchErrorcode(filepath[1], fileerrorcode);//MLinux̏ꍇbZ[Wo
			}else{//R[huxxx406(00xxx)vȊȌꍇ
				fileerrorcode = Integer.toString(winerrorcode/100000);
				searchErrorcode(filepath[0], fileerrorcode);
			}
		} else {//M悪Linux̏ꍇ
			filepath[0] =pre_linux_UX;//UX.dat̃pX
			filepath[1] =pre_linux_NT;//NT.dat̃pX
			int linuxerrorcode = Integer.parseInt(errorcode);
			if((linuxerrorcode/10000)==209){//R[hu02090xxxv̏ꍇ
				fileerrorcode = Integer.toString(linuxerrorcode%1000);
				searchErrorcode(filepath[1], fileerrorcode);//MWIndows̏ꍇbZ[Wo
				fileerrorcode = "0" + Integer.toString(linuxerrorcode%1000);
				searchErrorcode(filepath[0], fileerrorcode);//MLinux̏ꍇbZ[Wo
			}else{//R[hu02090xxxvȊȌꍇ
				fileerrorcode = errorcode;
				searchErrorcode(filepath[0], fileerrorcode);
			}
		}
		System.exit(1);//^[R[hu1vŏI
	}

	//G[t@CTEo
	public static void searchErrorcode(String filepath, String errorcode) {
		BufferedReader br = null;
		try {
			String line = "";//Yt@C1s
			String matchline = "";//Ys
			String message = "";//G[ڍ
			int errorcount = 0;//G[\
			File fp = new File(filepath);
			br = new BufferedReader(new FileReader(fp));
			while ((line = br.readLine()) != null) {// ŏIs܂œǂݍ
				matchline = line;
				StringTokenizer st = new StringTokenizer(matchline, ",");//ǂݍ񂾍su,vŋ؂
				int i = 0;
				while (st.hasMoreTokens()) {
					message = st.nextToken();
					if (i == 1){
						if(message.startsWith(errorcode)) {// 2Ԗڂ̃g[NG[R[hƑOvꍇ
							errorcount++;
							System.out.println();
							System.out.println("yG[ڍׁz");
						}else{// 2Ԗڂ̃g[NG[R[hƈvȂꍇIA̍sɐi
							break;
						}
					}else if(i>1){//G[bZ[W\
						System.out.println(message);
					}
					i++;
				}
			}
			if(errorcount >= 2){//G[\2ȏ̏ꍇ
				System.out.println();
				System.out.println("LG[ڍׂ̂ꂩAƂčl܂B");
			}
		} catch (FileNotFoundException e) {
			System.out.println(e.getMessage());
			e.printStackTrace();
		} catch (IOException e) {
			System.out.println(e.getMessage());
			e.printStackTrace();
		} finally {
			try{
				br.close();
			} catch (IOException e) {
				System.out.println(e.getMessage());
				e.printStackTrace();
			}
		}
	}
}
